// Squawk messenger. 
// Copyright (C) 2019  Yury Gubich <blue@macaw.me>
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "root.h"
#include <QDebug>
#include <QThread>

Root::Root(int& argc, char *argv[]) :
    QApplication(argc, argv)
    {}

bool Root::notify(QObject* receiver, QEvent* e) {
    try {
        return QApplication::notify(receiver, e);
    } catch(const std::runtime_error& e) {
        qDebug() << "std::runtime_error in thread : " << QThread::currentThreadId();
        qDebug() << e.what();
    } catch(const std::exception& e) {
        qDebug() << "std::exception in thread : " << QThread::currentThreadId();
        qDebug() << e.what();
    } catch(const int& e) {
        qDebug() << "int exception in thread : " << QThread::currentThreadId();
        qDebug() << e;
    } catch(...) {
        qDebug() << "exception thread : " << QThread::currentThreadId();
    }

    qDebug() << "catch in notify ";
    return false;
}
